/***********************************************************************/
/*                                                                     */
/*  FILE        :Analog_drv.c                                          */
/*  DATE        :Wed, Sep 03, 2009                                     */
/*  DESCRIPTION :Analog Function		                               */
/*  CPU TYPE    :H8SX/1655                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*  Modified	:DA8bit->10bit H8SX/1653->H8SX/1655  2010/05/09        */
/*  Modified	:for New Command protocol            2010/09/19        */
/***********************************************************************/
#include "iodefine.h"
#include "typedefine.h"
#include "Analog_Drv.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void Analog_Initalize(void);
#ifdef __cplusplus
}
#endif

//AiOH̏
void Analog_Initalize(void)
{
	//DAAADW[𓮍삳B
	MSTP.CRA.BIT._DA 	= 0;	//ԂDAW[͒~ĂB
	MSTP.CRA.BIT._AD 	= 0;	//ԂADW[͒~ĂB
	
	
	//DA|[g^ɁAnCCs[^XԂ0VɂB
	DA.DADR01T.BYTE     = 0;	// ʂQbit̓]
	DA.DADR0H  			= 0;	// DA0=0
	DA.DADR01T.BYTE     = 0;	// ʂQbit̓]
	DA.DADR1H  			= 0;	// DA1=0
	DA.DACR01.BIT.DAOE1	= 1;	// DA1o
	DA.DACR01.BIT.DAOE0	= 1;	// DA0o
	DA.DACR01.BIT.DAE	= 1;	// `lOCPDAϊ
	

	//AD|[g̓͂~B
	AD.ADCSR.BIT.ADF	= 0;	// A/DGhtO
	AD.ADCSR.BIT.ADIE	= 0;	// ADI荞݂֎~
	AD.ADCSR.BIT.ADST	= 0;	// A/Dϊ~
	AD.ADCSR.BIT.EXCKS  = 1;	// A/DgNbNZNg
	AD.ADCSR.BIT.CH		= 1;	// AN0,AN1AiO͂B
	AD.ADCR.BIT.TRGS	= 0;	// OgK[B
	AD.ADCR.BIT.SCANE	= 1;	// XL[h
	AD.ADCR.BIT.SCANS	= 0;	// 4`l
	AD.ADCR.BIT.CKS		= 3;	// őϊ=49Xe[g 
	
	
	//PortEԌvp̃v[uo͂ƂB
	PE.DDR = 0x0FF;	
}

void DA0_Out( _UINT vDA )
{
	unsigned char work;

	//DA0̏o͂ݒ肷BH8SX/1655́A10bitϊĂB
	work = vDA << 6;	//DADR01T 7bit 6bitڂɁAOɉ2bit𑗂10bitƂď
	DA.DADR01T.BYTE = work; 
	work = vDA >> 2;
	DA.DADR0H = work;
}

void DA1_Out( _UINT vDA )
{
	unsigned char work;

	//DA1̏o͂ݒ肷BH8SX/1655́A10bitϊĂB
	work = vDA << 6;	//DADR01T 7bit 6bitڂɁAOɉ2bit𑗂10bitƂď
	DA.DADR01T.BYTE = work; 
	work = vDA >> 2;
	DA.DADR1H = work;
}

//AD͂̎s
//^C~OdvȏꍇlāAAD0/AD1ɓǂލށB
void AD_in( _UINT * vAD0,_UINT * vAD1 )
{
	unsigned char work;

	PA.DR.BIT.B2 = 1;

	//AD̓͂JnB
	AD.ADCSR.BIT.ADF  = 0;	// A/DϊItOZbg
	AD.ADCSR.BIT.ADST = 1;	// A/DϊJn
	while( AD.ADCSR.BIT.ADF == 0 );	// A/DϊI҂ [vӁI
	AD.ADCSR.BIT.ADST = 0;	// A/DϊI
	
	*vAD0 = AD.ADDRA >> 6;	// AD0̓ǂݍ(16bit10bitɒli[ĂBj
	*vAD1 = AD.ADDRB >> 6;	// AD1̓ǂݍ(16bit10bitɒli[ĂBj

	PA.DR.BIT.B2 = 0;
	
}
