/***********************************************************************/
/*                                                                     */
/*  FILE        :USB_Drv.h                                             */
/*  DATE        :Wed, Sep 03, 2009                                     */
/*  DESCRIPTION :USB Function Header                                   */
/*  CPU TYPE    :H8SX/1653                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*                                                                     */
/***********************************************************************/
#include "typedefine.h"

union uni_USB_Proc_Flag {
    unsigned char BYTE;                 /*  Byte Access */
    struct {                            /*  Bit  Access */
		unsigned char Setup    		:1;	// ZbgAbvR}hM
		unsigned char EP0iSending 	:1;	// EP0(in)ɑM
		unsigned char EP1Received	:1;	// EP1(out)1pPbgMBd͂vB
	} BIT;
};

extern union uni_USB_Proc_Flag USB_Proc_Flag;
extern int  RemainSendSize;


//C痘pł֐
extern void USB_Initalize( void );
extern void USB_Proc( void );
extern int GetCommandFromReceiveBuf( _UBYTE *CommandBuf, char Delimiter );
extern void SetCommandToSendBuf(_UBYTE *CommandBuf, _UINT size );


//xN^[e[uƂ̊֘AẗׂɌJBiintprg.ĉݗpj
extern void USBINTN0_Proc( void );
extern void USBINTN1_Proc( void );
extern void USBINTN2_Proc( void );
extern void USBINTN3_Proc( void );
extern void USBINTRESUME_Proc( void );